// Copyright (C) 2021-2024 Bundesministerium des Innern und für Heimat, Referat DG II 6, Maßnahmen Enterprise Resource Management und Elektronische Verwaltungsarbeit
//
// SPDX-License-Identifier: MPL-2.0

// tslint:disable
/**
 * eGesetzgebung Platform
 * This is the rest interface offered by the eGesetzgebung Platform backend.  Please provide __JW Access Token__ using button \'Authorize\' to access protected endpoints. Use the following instructions to get token:  1. on CMD/Bash/Terminal: ```curl -d \"client_id=user-management\" -d \"client_secret=INSERT_IAM_SECRET\" -d \"grant_type=password&username=INSERT_USER_EMAIL&password=INSERT_USER_PASSWORD\" \"INSERT_IAM_URL/realms/bund/protocol/openid-connect/token\"``` 2. copy access_token (without quotes, you can use jq or other tools to extract this value automatically) 3. insert value into \'JWToken\' field under \'Authorize\' and press \'Authorize\' 4. now you should have access to user protected endpoint  __FYI:__ token expires after 60 seconds. On non-production systems only a warning is displayed so you can work smoothly, but on production systems you have to frequently provide a new token.
 *
 * The version of the OpenAPI document: 9.0.3
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import type { Observable } from 'rxjs';
import type { AjaxResponse } from 'rxjs/ajax';
import { BaseAPI, throwIfNullOrUndefined, encodeURI } from '../runtime';
import type { OperationOpts, HttpHeaders } from '../runtime';
import type {
    DokumentenmappeDTO,
} from '../models';

export interface GetDokumentenmappeBereitFuerKabinettverfahrenRequest {
    rvId: string;
}

export interface GetDokumentenmappeByIdRequest {
    id: string;
}

export interface GetDokumentenmappenRequest {
    rvId: string;
}

export interface GetDokumentenmappenFuerAbstimmungRequest {
    abstimmungId: string;
}

/**
 * no description
 */
export class EditorRemoteControllerApi extends BaseAPI {

    /**
     * Liefert die Dokumentenmappe aus LEA (Editor) anhand einer Regelungsvorhaben-ID im Status BEREIT_FUER_KABINETTVERFAHREN.
     * Lädt die Dokumentenmappe durch die übergebene Regelungsvorhaben-ID im Status BEREIT_FUER_KABINETTVERFAHREN.
     */
    getDokumentenmappeBereitFuerKabinettverfahren({ rvId }: GetDokumentenmappeBereitFuerKabinettverfahrenRequest): Observable<DokumentenmappeDTO>
    getDokumentenmappeBereitFuerKabinettverfahren({ rvId }: GetDokumentenmappeBereitFuerKabinettverfahrenRequest, opts?: OperationOpts): Observable<AjaxResponse<DokumentenmappeDTO>>
    getDokumentenmappeBereitFuerKabinettverfahren({ rvId }: GetDokumentenmappeBereitFuerKabinettverfahrenRequest, opts?: OperationOpts): Observable<DokumentenmappeDTO | AjaxResponse<DokumentenmappeDTO>> {
        throwIfNullOrUndefined(rvId, 'rvId', 'getDokumentenmappeBereitFuerKabinettverfahren');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<DokumentenmappeDTO>({
            url: '/editor-remote/dokumentenmappen/{rvId}/bereit-fuer-kabinettverfahren'.replace('{rvId}', encodeURI(rvId)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Liefert eine Dokumentenmappe aus LEA (Editor) anhand einer Dokumentenmappen-ID.
     * Lädt die Dokumentenmappe durch die übergebene ID.
     */
    getDokumentenmappeById({ id }: GetDokumentenmappeByIdRequest): Observable<DokumentenmappeDTO>
    getDokumentenmappeById({ id }: GetDokumentenmappeByIdRequest, opts?: OperationOpts): Observable<AjaxResponse<DokumentenmappeDTO>>
    getDokumentenmappeById({ id }: GetDokumentenmappeByIdRequest, opts?: OperationOpts): Observable<DokumentenmappeDTO | AjaxResponse<DokumentenmappeDTO>> {
        throwIfNullOrUndefined(id, 'id', 'getDokumentenmappeById');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<DokumentenmappeDTO>({
            url: '/editor-remote/dokumentenmappe/{id}'.replace('{id}', encodeURI(id)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Liefert eine Liste der Dokumentenmappen aus LEA (Editor) anhand einer Regelungsvorhaben-ID.
     * Lädt Dokumentenmappen durch die übergebene Regelungsvorhaben-ID.
     */
    getDokumentenmappen({ rvId }: GetDokumentenmappenRequest): Observable<Array<DokumentenmappeDTO>>
    getDokumentenmappen({ rvId }: GetDokumentenmappenRequest, opts?: OperationOpts): Observable<AjaxResponse<Array<DokumentenmappeDTO>>>
    getDokumentenmappen({ rvId }: GetDokumentenmappenRequest, opts?: OperationOpts): Observable<Array<DokumentenmappeDTO> | AjaxResponse<Array<DokumentenmappeDTO>>> {
        throwIfNullOrUndefined(rvId, 'rvId', 'getDokumentenmappen');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<Array<DokumentenmappeDTO>>({
            url: '/editor-remote/dokumentenmappen/{rvId}'.replace('{rvId}', encodeURI(rvId)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Liefert eine Liste der Dokumentenmappen aus LEA (Editor) anhand einer Abstimmung-ID.
     * Lädt Dokumentenmappen durch die übergebene Abstimmung-ID.
     */
    getDokumentenmappenFuerAbstimmung({ abstimmungId }: GetDokumentenmappenFuerAbstimmungRequest): Observable<Array<DokumentenmappeDTO>>
    getDokumentenmappenFuerAbstimmung({ abstimmungId }: GetDokumentenmappenFuerAbstimmungRequest, opts?: OperationOpts): Observable<AjaxResponse<Array<DokumentenmappeDTO>>>
    getDokumentenmappenFuerAbstimmung({ abstimmungId }: GetDokumentenmappenFuerAbstimmungRequest, opts?: OperationOpts): Observable<Array<DokumentenmappeDTO> | AjaxResponse<Array<DokumentenmappeDTO>>> {
        throwIfNullOrUndefined(abstimmungId, 'abstimmungId', 'getDokumentenmappenFuerAbstimmung');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<Array<DokumentenmappeDTO>>({
            url: '/editor-remote/dokumentenmappen/abstimmung/{abstimmungId}'.replace('{abstimmungId}', encodeURI(abstimmungId)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

}
